"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Resolver = void 0;
var Resolver;
(function (Resolver) {
    function isVoidType(param) {
        return typeof param === 'undefined' || param.typeName === 'void';
    }
    Resolver.isVoidType = isVoidType;
    function isEnumType(param) {
        return param.typeName === 'enum';
    }
    Resolver.isEnumType = isEnumType;
    function isArrayType(param) {
        return param.typeName === 'array';
    }
    Resolver.isArrayType = isArrayType;
    function isNestedObjectLiteralType(param) {
        return param.typeName === 'nestedObjectLiteral';
    }
    Resolver.isNestedObjectLiteralType = isNestedObjectLiteralType;
    function isIntersectionType(param) {
        return param.typeName === 'intersection';
    }
    Resolver.isIntersectionType = isIntersectionType;
    function isUnionType(param) {
        return param.typeName === 'union';
    }
    Resolver.isUnionType = isUnionType;
    function isRefEnumType(param) {
        return param.typeName === 'refEnum';
    }
    Resolver.isRefEnumType = isRefEnumType;
    function isReferenceType(param) {
        return param.typeName === 'refEnum' || param.typeName === 'refAlias' || param.typeName === 'refObject';
    }
    Resolver.isReferenceType = isReferenceType;
})(Resolver = exports.Resolver || (exports.Resolver = {}));
//# sourceMappingURL=type.js.map