import { Node } from 'typescript';
/**
 * Get Decorators for a specific node.
 *
 * @param node
 * @param isMatching
 */
export declare function getDecorators(node: Node, isMatching: (identifier: DecoratorData) => boolean): Array<DecoratorData>;
export declare function getDecoratorName(node: Node, isMatching: (identifier: DecoratorData) => boolean): string | undefined;
export declare function getDecoratorTextValue(node: Node, isMatching: (identifier: DecoratorData) => boolean): string;
export declare function getDecoratorOptions(node: Node, isMatching: (identifier: DecoratorData) => boolean): {
    [key: string]: any;
};
export declare function isDecorator(node: Node, isMatching: (identifier: DecoratorData) => boolean): boolean;
export interface DecoratorData {
    text: string;
    arguments: Array<any>;
    typeArguments: Array<any>;
}
